package tools.descartes.dql.connector.kieker.structures.interfaces;

import tools.descartes.dql.connector.kieker.structures.AbstractValue;

public class InterfaceMapValue  extends AbstractValue<Long>{

	public InterfaceMapValue(long timestamp, long executionTime){
		super.put(timestamp, executionTime);
	}

	/**
	 * This method enhances information that shares the same InterfaceMapKey.
	 * Thus it should only be invoked to do so.
	 * 
	 * @param executionTime describes the term from start to termination of the interface
	 * @return InterfaceMapValue which contains the new updated information
	 */
	public synchronized InterfaceMapValue enhance(long timestamp, long executionTime){

		super.put(timestamp, executionTime);
		return this;
	}



	@Override
	public String toString(){
		StringBuilder builder = new StringBuilder();
		builder.append("timestamp \t \t|  execution times \n");
		for (TimeDataPair<Long, Long> pair : super.getArrayList()) {
			builder.append("\t");			
			builder.append(String.format("%s", pair.toString()));
			builder.append("\n");
		}
		return builder.toString();
	}


}